import{Linkifier as e,Revealer as t}from"../common/common.js";import{AccessibilityModel as a,DOMModel as s,OverlayModel as i,SDKModel as r}from"../sdk/sdk.js";import{View as n,TreeOutline as o,Tooltip as l,UIUtils as d,TextPrompt as c,ARIAUtils as u,ContextMenu as m,ThrottledWidget as h,ViewManager as p,Context as b}from"../ui/ui.js";import{Runtime as _}from"../root/root.js";import{userMetrics as f,UserMetrics as g}from"../host/host.js";const v={disabled:{name:ls`Disabled`,description:ls`If true, this element currently cannot be interacted with.`,group:"AXGlobalStates"},invalid:{name:ls`Invalid user entry`,description:ls`If true, this element's user-entered value does not conform to validation requirement.`,group:"AXGlobalStates"},editable:{name:ls`Editable`,description:ls`If and how this element can be edited.`},focusable:{name:ls`Focusable`,description:ls`If true, this element can receive focus.`},focused:{name:ls`Focused`,description:ls`If true, this element currently has focus.`},settable:{name:ls`Can set value`,description:ls`Whether the value of this element can be set.`},live:{name:ls`Live region`,description:ls`Whether and what priority of live updates may be expected for this element.`,group:"AXLiveRegionAttributes"},atomic:{name:ls`Atomic (live regions)`,description:ls`If this element may receive live updates, whether the entire live region should be presented to the user on changes, or only changed nodes.`,group:"AXLiveRegionAttributes"},relevant:{name:ls`Relevant (live regions)`,description:ls`If this element may receive live updates, what type of updates should trigger a notification.`,group:"AXLiveRegionAttributes"},busy:{name:ls`Busy (live regions)`,description:ls`Whether this element or its subtree are currently being updated (and thus may be in an inconsistent state).`,group:"AXLiveRegionAttributes"},root:{name:ls`Live region root`,description:ls`If this element may receive live updates, the root element of the containing live region.`,group:"AXLiveRegionAttributes"},autocomplete:{name:ls`Has autocomplete`,description:ls`Whether and what type of autocomplete suggestions are currently provided by this element.`,group:"AXWidgetAttributes"},haspopup:{name:ls`Has popup`,description:ls`Whether this element has caused some kind of pop-up (such as a menu) to appear.`,group:"AXWidgetAttributes"},level:{name:ls`Level`,description:ls`The hierarchical level of this element.`,group:"AXWidgetAttributes"},multiselectable:{name:ls`Multi-selectable`,description:ls`Whether a user may select more than one option from this widget.`,group:"AXWidgetAttributes"},orientation:{name:ls`Orientation`,description:ls`Whether this linear element's orientation is horizontal or vertical.`,group:"AXWidgetAttributes"},multiline:{name:ls`Multi-line`,description:ls`Whether this text box may have more than one line.`,group:"AXWidgetAttributes"},readonly:{name:ls`Read-only`,description:ls`If true, this element may be interacted with, but its value cannot be changed.`,group:"AXWidgetAttributes"},required:{name:ls`Required`,description:ls`Whether this element is a required field in a form.`,group:"AXWidgetAttributes"},valuemin:{name:ls`Minimum value`,description:ls`For a range widget, the minimum allowed value.`,group:"AXWidgetAttributes"},valuemax:{name:ls`Maximum value`,description:ls`For a range widget, the maximum allowed value.`,group:"AXWidgetAttributes"},valuetext:{name:ls`Value description`,description:ls`A human-readable version of the value of a range widget (where necessary).`,group:"AXWidgetAttributes"},checked:{name:ls`Checked`,description:ls`Whether this checkbox, radio button or tree item is checked, unchecked, or mixed (e.g. has both checked and un-checked children).`,group:"AXWidgetStates"},expanded:{name:ls`Expanded`,description:ls`Whether this element, or another grouping element it controls, is expanded.`,group:"AXWidgetStates"},pressed:{name:ls`Pressed`,description:ls`Whether this toggle button is currently in a pressed state.`,group:"AXWidgetStates"},selected:{name:ls`Selected`,description:ls`Whether the option represented by this element is currently selected.`,group:"AXWidgetStates"},activedescendant:{name:ls`Active descendant`,description:ls`The descendant of this element which is active; i.e. the element to which focus should be delegated.`,group:"AXRelationshipAttributes"},flowto:{name:ls`Flows to`,description:ls`Element to which the user may choose to navigate after this one, instead of the next element in the DOM order.`,group:"AXRelationshipAttributes"},controls:{name:ls`Controls`,description:ls`Element or elements whose content or presence is/are controlled by this widget.`,group:"AXRelationshipAttributes"},describedby:{name:ls`Described by`,description:ls`Element or elements which form the description of this element.`,group:"AXRelationshipAttributes"},labelledby:{name:ls`Labeled by`,description:ls`Element or elements which may form the name of this element.`,group:"AXRelationshipAttributes"},owns:{name:ls`Owns`,description:ls`Element or elements which should be considered descendants of this element, despite not being descendants in the DOM.`,group:"AXRelationshipAttributes"},name:{name:ls`Name`,description:ls`The computed name of this element.`,group:"Default"},role:{name:ls`Role`,description:ls`Indicates the purpose of this element, such as a user interface idiom for a widget, or structural role within a document.`,group:"Default"},value:{name:ls`Value`,description:ls`The value of this element; this may be user-provided or developer-provided, depending on the element.`,group:"Default"},help:{name:ls`Help`,description:ls`The computed help text for this element.`,group:"Default"},description:{name:ls`Description`,description:ls`The accessible description for this element.`,group:"Default"}},x={attribute:{name:ls`From attribute`,description:ls`Value from attribute.`},implicit:{name:ls`Implicit`,description:ls`Implicit value.`},style:{name:ls`From style`,description:ls`Value from style.`},contents:{name:ls`Contents`,description:ls`Value from element contents.`},placeholder:{name:ls`From placeholder attribute`,description:ls`Value from placeholder attribute.`},relatedElement:{name:ls`Related element`,description:ls`Value from related element.`}},y={figcaption:{name:ls`From caption`,description:ls`Value from figcaption element.`},label:{name:ls`From label`,description:ls`Value from label element.`},labelfor:{name:ls`From label (for)`,description:ls`Value from label element with for= attribute.`},labelwrapped:{name:ls`From label (wrapped)`,description:ls`Value from label element wrapped.`},legend:{name:ls`From legend`,description:ls`Value from legend element.`},rubyannotation:{name:ls`From ruby annotation`,description:ls`Value from native HTML ruby annotation.`},tablecaption:{name:ls`From caption`,description:ls`Value from table caption.`},title:{name:ls`From title`,description:ls`Value from title attribute.`},other:{name:ls`From native HTML`,description:ls`Value from native HTML (unknown source).`}};var E=Object.freeze({__proto__:null,AXAttributes:v,AXSourceTypes:x,AXNativeSourceTypes:y});class N extends n.SimpleView{constructor(e){super(e),this._axNode=null,this.registerRequiredCSS("accessibility/accessibilityProperties.css",{enableLegacyPatching:!1})}setAXNode(e){}node(){return this._node||null}setNode(e){this._node=e}createInfo(e,t){const a=t||"gray-info-message",s=this.element.createChild("div",a);return s.textContent=e,s}createTreeOutline(){const e=new o.TreeOutlineInShadow;return e.registerRequiredCSS("accessibility/accessibilityNode.css",{enableLegacyPatching:!1}),e.registerRequiredCSS("accessibility/accessibilityProperties.css",{enableLegacyPatching:!1}),e.registerRequiredCSS("object_ui/objectValue.css",{enableLegacyPatching:!0}),e.element.classList.add("hidden"),e.hideOverflow(),this.element.appendChild(e.element),e}}var A=Object.freeze({__proto__:null,AccessibilitySubPane:N});class w extends N{constructor(){super(ls`Computed Properties`),this._axNode=null,this.contentElement.classList.add("ax-subpane"),this._noNodeInfo=this.createInfo(ls`No accessibility node`),this._ignoredInfo=this.createInfo(ls`Accessibility node not exposed`,"ax-ignored-info hidden"),this._treeOutline=this.createTreeOutline(),this._ignoredReasonsTree=this.createTreeOutline(),this.element.classList.add("accessibility-computed"),this.registerRequiredCSS("accessibility/accessibilityNode.css",{enableLegacyPatching:!1}),this._treeOutline.setFocusable(!0)}setAXNode(e){if(this._axNode===e)return;this._axNode=e;const t=this._treeOutline;t.removeChildren();const s=this._ignoredReasonsTree;if(s.removeChildren(),!e)return t.element.classList.add("hidden"),this._ignoredInfo.classList.add("hidden"),s.element.classList.add("hidden"),this._noNodeInfo.classList.remove("hidden"),void this.element.classList.add("ax-ignored-node-pane");if(e.ignored()){this._noNodeInfo.classList.add("hidden"),t.element.classList.add("hidden"),this.element.classList.add("ax-ignored-node-pane"),this._ignoredInfo.classList.remove("hidden"),s.element.classList.remove("hidden");const a=e.ignoredReasons();for(const t of a)i=t,s.appendChild(new F(i,e));return void(s.firstChild()||s.element.classList.add("hidden"))}var i;function r(a){t.appendChild(new R(a,e))}this.element.classList.remove("ax-ignored-node-pane"),this._ignoredInfo.classList.add("hidden"),s.element.classList.add("hidden"),this._noNodeInfo.classList.add("hidden"),t.element.classList.remove("hidden");for(const t of e.coreProperties())r(t);const n=e.role();if(n){r({name:a.CoreAxPropertyName.Role,value:n})}for(const t of e.properties())r(t);const o=t.firstChild();o&&o.select(!0,!1)}setNode(e){super.setNode(e),this._axNode=null}}class C extends o.TreeElement{constructor(e){super(""),this._axNode=e}static createSimpleValueElement(e,t){let a;const s=Protocol.Accessibility.AXValueType;let i;e&&e!==s.ValueUndefined&&e!==s.ComputedString?(a=document.createElement("span"),a.classList.add("monospace")):a=document.createElement("span");return i=e&&L.has(e)?'"'+t.replace(/\n/g,"↵")+'"':String(t),e&&e in k&&a.classList.add(k[e]),a.setTextContentTruncatedIfNeeded(i||""),l.Tooltip.install(a,String(t)||""),a}static createExclamationMark(e){const t=document.createElement("span",{is:"dt-icon-label"});return t.type="smallicon-warning",l.Tooltip.install(t,e),t}appendNameElement(e){const t=document.createElement("span");if(e in v){const a=v[e];t.textContent=a.name,l.Tooltip.install(t,a.description),t.classList.add("ax-readable-name")}else t.textContent=e,t.classList.add("ax-name"),t.classList.add("monospace");this.listItemElement.appendChild(t)}appendValueElement(e){const t=Protocol.Accessibility.AXValueType;if(e.type===t.Idref||e.type===t.Node||e.type===t.IdrefList||e.type===t.NodeList)return void this.appendRelatedNodeListValueElement(e);if(e.sources){const t=e.sources;for(let e=0;e<t.length;e++){const a=t[e],s=new I(a,this._axNode);this.appendChild(s)}this.expand()}const a=C.createSimpleValueElement(e.type,String(e.value));this.listItemElement.appendChild(a)}appendRelatedNode(e,t){const a=new s.DeferredDOMNode(this._axNode.accessibilityModel().target(),e.backendDOMNodeId),i=new P({deferredNode:a,idref:void 0},e);this.appendChild(i)}appendRelatedNodeInline(e){const t=new s.DeferredDOMNode(this._axNode.accessibilityModel().target(),e.backendDOMNodeId),a=new M({deferredNode:t,idref:void 0},e);this.listItemElement.appendChild(a.render())}appendRelatedNodeListValueElement(e){!e.relatedNodes||1!==e.relatedNodes.length||e.value?(e.relatedNodes&&e.relatedNodes.forEach(this.appendRelatedNode,this),e.relatedNodes&&e.relatedNodes.length<=3?this.expand():this.collapse()):this.appendRelatedNodeInline(e.relatedNodes[0])}}const k={attribute:"ax-value-string",boolean:"object-value-boolean",booleanOrUndefined:"object-value-boolean",computedString:"ax-readable-string",idref:"ax-value-string",idrefList:"ax-value-string",integer:"object-value-number",internalRole:"ax-internal-role",number:"ax-value-number",role:"ax-role",string:"ax-value-string",tristate:"object-value-boolean",valueUndefined:"ax-value-undefined"},L=new Set([Protocol.Accessibility.AXValueType.String,Protocol.Accessibility.AXValueType.ComputedString,Protocol.Accessibility.AXValueType.IdrefList,Protocol.Accessibility.AXValueType.Idref]);class R extends C{constructor(e,t){super(t),this._property=e,this.toggleOnClick=!0,this.listItemElement.classList.add("property")}onattach(){this._update()}_update(){this.listItemElement.removeChildren(),this.appendNameElement(this._property.name),this.listItemElement.createChild("span","separator").textContent=": ",this.appendValueElement(this._property.value)}}class I extends C{constructor(e,t){super(t),this._source=e}onattach(){this._update()}appendRelatedNodeWithIdref(e,t){const a=new s.DeferredDOMNode(this._axNode.accessibilityModel().target(),e.backendDOMNodeId),i=new P({deferredNode:a,idref:t},e);this.appendChild(i)}appendIDRefValueElement(e){if(null===e.value)return;const t=e.relatedNodes||[];if(""===e.value){for(const e of t){const t=e.idref||"";this.appendRelatedNodeWithIdref(e,t)}return}const a=e.value.trim().split(/\s+/);for(const e of a){const s=t.find((t=>t.idref===e));s?this.appendRelatedNodeWithIdref(s,e):1===a.length?this.listItemElement.appendChild(new M({deferredNode:void 0,idref:e}).render()):this.appendChild(new P({deferredNode:void 0,idref:e}))}}appendRelatedNodeListValueElement(e){const t=e.relatedNodes,a=t?t.length:0;e.type===Protocol.Accessibility.AXValueType.IdrefList||e.type===Protocol.Accessibility.AXValueType.Idref?this.appendIDRefValueElement(e):super.appendRelatedNodeListValueElement(e),a<=3?this.expand():this.collapse()}appendSourceNameElement(e){const t=document.createElement("span"),a=Protocol.Accessibility.AXValueSourceType,s=e.type;switch(s){case a.Attribute:case a.Placeholder:case a.RelatedElement:if(e.nativeSource){const a=e.nativeSource;t.textContent=y[a].name,l.Tooltip.install(t,y[a].description),t.classList.add("ax-readable-name");break}t.textContent=e.attribute||null,t.classList.add("ax-name"),t.classList.add("monospace");break;default:s in x?(t.textContent=x[s].name,l.Tooltip.install(t,x[s].description),t.classList.add("ax-readable-name")):(console.warn(s,"not in AXSourceTypes"),t.textContent=s)}this.listItemElement.appendChild(t)}_update(){if(this.listItemElement.removeChildren(),this._source.invalid){const e=C.createExclamationMark(ls`Invalid source.`);this.listItemElement.appendChild(e),this.listItemElement.classList.add("ax-value-source-invalid")}else this._source.superseded&&this.listItemElement.classList.add("ax-value-source-unused");if(this.appendSourceNameElement(this._source),this.listItemElement.createChild("span","separator").textContent=": ",this._source.attributeValue)this.appendValueElement(this._source.attributeValue),d.createTextChild(this.listItemElement," ");else if(this._source.nativeSourceValue)this.appendValueElement(this._source.nativeSourceValue),d.createTextChild(this.listItemElement," "),this._source.value&&this.appendValueElement(this._source.value);else if(this._source.value)this.appendValueElement(this._source.value);else{const e=C.createSimpleValueElement(Protocol.Accessibility.AXValueType.ValueUndefined,ls`Not specified`);this.listItemElement.appendChild(e),this.listItemElement.classList.add("ax-value-source-unused")}this._source.value&&this._source.superseded&&this.listItemElement.classList.add("ax-value-source-superseded")}}class P extends o.TreeElement{constructor(e,t){super(""),this._value=t,this._axRelatedNodeElement=new M(e,t),this.selectable=!0}onattach(){this.listItemElement.appendChild(this._axRelatedNodeElement.render()),this._value&&this._value.text&&this.listItemElement.appendChild(C.createSimpleValueElement(Protocol.Accessibility.AXValueType.ComputedString,this._value.text))}onenter(){return this._axRelatedNodeElement.revealNode(),!0}}class M{constructor(e,t){this._deferredNode=e.deferredNode,this._idref=e.idref,this._value=t}render(){const t=document.createElement("span");if(this._deferredNode){const a=document.createElement("span");t.appendChild(a),this._deferredNode.resolvePromise().then((t=>{e.Linkifier.linkify(t,{tooltip:void 0,preventKeyboardFocus:!0}).then((e=>a.appendChild(e)))}))}else if(this._idref){t.classList.add("invalid");const e=C.createExclamationMark(ls`No node with this ID.`);d.createTextChild(e,this._idref),t.appendChild(e)}return t}revealNode(){this._deferredNode&&this._deferredNode.resolvePromise().then((e=>t.reveal(e)))}}class F extends C{constructor(e,t){super(t),this._property=e,this._axNode=t,this.toggleOnClick=!0,this.selectable=!1}static createReasonElement(e,t){let a=null;switch(e){case"activeModalDialog":a=d.formatLocalized("Element is hidden by active modal dialog: ",[]);break;case"ancestorIsLeafNode":a=d.formatLocalized("Ancestor's children are all presentational: ",[]);break;case"ariaHiddenElement":{const e=document.createElement("span",{is:"source-code"}).textContent="aria-hidden";a=d.formatLocalized("Element is %s.",[e]);break}case"ariaHiddenSubtree":{const e=document.createElement("span",{is:"source-code"}).textContent="aria-hidden",t=document.createElement("span",{is:"source-code"}).textContent="true";a=d.formatLocalized("%s is %s on ancestor: ",[e,t]);break}case"emptyAlt":a=d.formatLocalized("Element has empty alt text.",[]);break;case"emptyText":a=d.formatLocalized("No text content.",[]);break;case"inertElement":a=d.formatLocalized("Element is inert.",[]);break;case"inertSubtree":a=d.formatLocalized("Element is in an inert subtree from ",[]);break;case"inheritsPresentation":a=d.formatLocalized("Element inherits presentational role from ",[]);break;case"labelContainer":a=d.formatLocalized("Part of label element: ",[]);break;case"labelFor":a=d.formatLocalized("Label for ",[]);break;case"notRendered":a=d.formatLocalized("Element is not rendered.",[]);break;case"notVisible":a=d.formatLocalized("Element is not visible.",[]);break;case"presentationalRole":{const e=t&&t.role()||"",s=document.createElement("span",{is:"source-code"}).textContent="role="+e;a=d.formatLocalized("Element has %s.",[s]);break}case"probablyPresentational":a=d.formatLocalized("Element is presentational.",[]);break;case"staticTextUsedAsNameFor":a=d.formatLocalized("Static text node is used as name for ",[]);break;case"uninteresting":a=d.formatLocalized("Element not interesting for accessibility.",[])}return a&&a.classList.add("ax-reason"),a}onattach(){this.listItemElement.removeChildren(),this._reasonElement=F.createReasonElement(this._property.name,this._axNode),this._reasonElement&&this.listItemElement.appendChild(this._reasonElement);const e=this._property.value;e.type===Protocol.Accessibility.AXValueType.Idref&&this.appendRelatedNodeListValueElement(e)}}var S=Object.freeze({__proto__:null,AXNodeSubPane:w,AXNodePropertyTreeElement:C,TypeStyles:k,StringProperties:L,AXNodePropertyTreePropertyElement:R,AXValueSourceTreeElement:I,AXRelatedNodeSourceTreeElement:P,AXRelatedNodeElement:M,AXNodeIgnoredReasonTreeElement:F});const V={attributes:[{type:"IDREF",name:"aria-activedescendant"},{default:"false",type:"boolean",name:"aria-atomic"},{default:"none",enum:["inline","list","both","none"],type:"token",name:"aria-autocomplete"},{default:"false",type:"boolean",name:"aria-busy"},{default:"undefined",enum:["true","false","mixed","undefined"],type:"token",name:"aria-checked"},{type:"integer",name:"aria-colcount"},{type:"integer",name:"aria-colindex"},{type:"integer",name:"aria-colspan"},{type:"IDREF_list",name:"aria-controls"},{default:"false",enum:["page","step","location","date","time","true","false"],type:"token",name:"aria-current"},{type:"IDREF_list",name:"aria-describedby"},{type:"string",name:"aria-description"},{type:"IDREF",name:"aria-details"},{default:"false",type:"boolean",name:"aria-disabled"},{default:"none",enum:["copy","move","link","execute","popup","none"],type:"token_list",name:"aria-dropeffect"},{type:"IDREF",name:"aria-errormessage"},{default:"undefined",enum:["true","false","undefined"],type:"token",name:"aria-expanded"},{type:"IDREF_list",name:"aria-flowto"},{default:"undefined",enum:["true","false","undefined"],type:"token",name:"aria-grabbed"},{default:"false",enum:["false","true","menu","listbox","tree","grid","dialog"],type:"token",name:"aria-haspopup"},{default:"undefined",enum:["true","false","undefined"],type:"token",name:"aria-hidden"},{default:"false",enum:["grammar","false","spelling","true"],type:"token",name:"aria-invalid"},{type:"string",name:"aria-keyshortcuts"},{type:"string",name:"aria-label"},{type:"IDREF_list",name:"aria-labelledby"},{type:"IDREF_list",name:"aria-labeledby"},{type:"integer",name:"aria-level"},{default:"off",enum:["off","polite","assertive"],type:"token",name:"aria-live"},{default:"false",type:"boolean",name:"aria-modal"},{default:"false",type:"boolean",name:"aria-multiline"},{default:"false",type:"boolean",name:"aria-multiselectable"},{default:"undefined",enum:["horizontal","undefined","vertical"],type:"token",name:"aria-orientation"},{type:"IDREF_list",name:"aria-owns"},{type:"string",name:"aria-placeholder"},{type:"integer",name:"aria-posinset"},{default:"undefined",enum:["true","false","mixed","undefined"],type:"token",name:"aria-pressed"},{default:"false",type:"boolean",name:"aria-readonly"},{default:"additions text",enum:["additions","removals","text","all"],type:"token_list",name:"aria-relevant"},{default:"false",type:"boolean",name:"aria-required"},{type:"string",name:"aria-roledescription"},{type:"integer",name:"aria-rowcount"},{type:"integer",name:"aria-rowindex"},{type:"integer",name:"aria-rowspan"},{default:"undefined",enum:["true","false","undefined"],type:"token",name:"aria-selected"},{type:"integer",name:"aria-setsize"},{default:"none",enum:["ascending","descending","none","other"],type:"token",name:"aria-sort"},{type:"decimal",name:"aria-valuemax"},{type:"decimal",name:"aria-valuemin"},{type:"decimal",name:"aria-valuenow"},{type:"string",name:"aria-valuetext"}],roles:[{implicitValues:{"aria-atomic":"true","aria-live":"assertive"},superclasses:["section"],name:"alert",nameFrom:["author"]},{superclasses:["alert","dialog"],name:"alertdialog",nameRequired:!0,nameFrom:["author"]},{superclasses:["structure"],name:"application",nameRequired:!0,nameFrom:["author"]},{supportedAttributes:["aria-posinset","aria-setsize"],superclasses:["document"],name:"article",nameFrom:["author"]},{superclasses:["landmark"],name:"banner",nameFrom:["author"]},{name:"button",nameRequired:!0,nameFrom:["contents","author"],supportedAttributes:["aria-expanded","aria-pressed"],superclasses:["command"],childrenPresentational:!0},{scope:"row",supportedAttributes:["aria-colindex","aria-colspan","aria-rowindex","aria-rowspan"],superclasses:["section"],name:"cell",namefrom:["contents","author"]},{name:"checkbox",nameRequired:!0,implicitValues:{"aria-checked":!1},requiredAttributes:["aria-checked"],nameFrom:["contents","author"],supportedAttributes:["aria-readonly"],superclasses:["input"]},{name:"columnheader",nameRequired:!0,nameFrom:["contents","author"],supportedAttributes:["aria-sort"],superclasses:["gridcell","sectionhead","widget"],scope:["row"]},{name:"combobox",nameRequired:!0,implicitValues:{"aria-haspopup":"listbox","aria-expanded":"false"},requiredAttributes:["aria-controls","aria-expanded"],mustContain:["textbox"],nameFrom:["author"],supportedAttributes:["aria-autocomplete","aria-readonly","aria-required"],superclasses:["select"]},{abstract:!0,superclasses:["widget"],name:"command",nameFrom:["author"]},{superclasses:["landmark"],name:"complementary",nameFrom:["author"]},{supportedAttributes:["aria-activedescendant"],abstract:!0,superclasses:["widget"],name:"composite",nameFrom:["author"]},{superclasses:["landmark"],name:"contentinfo",nameFrom:["author"]},{superclasses:["section"],name:"definition",nameFrom:["author"]},{superclasses:["window"],name:"dialog",nameRequired:!0,nameFrom:["author"]},{superclasses:["list"],name:"directory",nameFrom:["author"]},{supportedAttributes:["aria-expanded"],superclasses:["structure"],name:"document",nameRequired:!1,nameFrom:["author"]},{nameRequired:!1,superclasses:["list"],name:"feed",mustContain:["article"],nameFrom:["author"]},{superclasses:["section"],name:"figure",nameRequired:!1,namefrom:["author"]},{superclasses:["landmark"],name:"form",nameFrom:["author"]},{name:"grid",nameRequired:!0,nameFrom:["author"],mustContain:["row"],supportedAttributes:["aria-level","aria-multiselectable","aria-readonly"],superclasses:["composite","table"]},{name:"gridcell",nameRequired:!0,nameFrom:["contents","author"],supportedAttributes:["aria-readonly","aria-required","aria-selected"],superclasses:["cell","widget"],scope:["row"]},{supportedAttributes:["aria-activedescendant"],superclasses:["section"],name:"group",nameFrom:["author"]},{name:"heading",nameRequired:!0,implicitValues:{"aria-level":"2"},namefrom:["contents","author"],supportedAttributes:["aria-level"],superclasses:["sectionhead"]},{childrenPresentational:!0,superclasses:["section"],name:"img",nameRequired:!0,nameFrom:["author"]},{abstract:!0,superclasses:["widget"],name:"input",nameFrom:["author"]},{abstract:!0,superclasses:["section"],name:"landmark",nameRequired:!1,nameFrom:["author"]},{supportedAttributes:["aria-expanded"],superclasses:["command"],name:"link",nameRequired:!0,nameFrom:["contents","author"]},{implicitValues:{"aria-orientation":"vertical"},superclasses:["section"],name:"list",mustContain:["listitem"],nameFrom:["author"]},{name:"listbox",nameRequired:!0,implicitValues:{"aria-orientation":"vertical"},nameFrom:["author"],mustContain:["option"],supportedAttributes:["aria-multiselectable","aria-readonly","aria-required"],superclasses:["select"]},{scope:["group","list"],supportedAttributes:["aria-level","aria-posinset","aria-setsize"],superclasses:["section"],name:"listitem",nameFrom:["author"]},{implicitValues:{"aria-live":"polite"},superclasses:["section"],name:"log",nameRequired:!0,nameFrom:["author"]},{superclasses:["landmark"],name:"main",nameFrom:["author"]},{superclasses:["section"],name:"marquee",nameRequired:!0,nameFrom:["author"]},{childrenPresentational:!0,superclasses:["section"],name:"math",nameRequired:!0,nameFrom:["author"]},{implicitValues:{"aria-orientation":"vertical"},superclasses:["select"],name:"menu",mustContain:["group","menuitemradio","menuitem","menuitemcheckbox","menuitemradio"],nameFrom:["author"]},{implicitValues:{"aria-orientation":"horizontal"},superclasses:["menu"],name:"menubar",mustContain:["menuitem","menuitemradio","menuitemcheckbox"],nameFrom:["author"]},{scope:["group","menu","menubar"],superclasses:["command"],name:"menuitem",nameRequired:!0,nameFrom:["contents","author"]},{name:"menuitemcheckbox",nameRequired:!0,implicitValues:{"aria-checked":!1},nameFrom:["contents","author"],superclasses:["checkbox","menuitem"],childrenPresentational:!0,scope:["menu","menubar"]},{name:"menuitemradio",nameRequired:!0,implicitValues:{"aria-checked":!1},nameFrom:["contents","author"],superclasses:["menuitemcheckbox","radio"],childrenPresentational:!0,scope:["menu","menubar","group"]},{superclasses:["landmark"],name:"navigation",nameFrom:["author"]},{name:"none",superclasses:["structure"]},{superclasses:["section"],name:"note",nameFrom:["author"]},{name:"option",nameRequired:!0,implicitValues:{"aria-selected":"false"},requiredAttributes:["aria-selected"],nameFrom:["contents","author"],supportedAttributes:["aria-checked","aria-posinset","aria-setsize"],superclasses:["input"],childrenPresentational:!0,scope:["listbox"]},{name:"presentation",superclasses:["structure"]},{childrenPresentational:!0,superclasses:["range"],name:"progressbar",nameRequired:!0,nameFrom:["author"]},{name:"radio",nameRequired:!0,implicitValues:{"aria-checked":"false"},requiredAttributes:["aria-checked"],nameFrom:["contents","author"],supportedAttributes:["aria-posinset","aria-setsize"],superclasses:["input"],childrenPresentational:!0},{name:"radiogroup",nameRequired:!0,nameFrom:["author"],mustContain:["radio"],supportedAttributes:["aria-readonly","aria-required"],superclasses:["select"]},{supportedAttributes:["aria-valuemax","aria-valuemin","aria-valuenow","aria-valuetext"],abstract:!0,superclasses:["widget"],name:"range",nameFrom:["author"]},{superclasses:["landmark"],name:"region",nameRequired:!0,nameFrom:["author"]},{supportedAttributes:["aria-atomic","aria-busy","aria-controls","aria-current","aria-describedby","aria-details","aria-disabled","aria-dropeffect","aria-errormessage","aria-flowto","aria-grabbed","aria-haspopup","aria-hidden","aria-invalid","aria-keyshortcuts","aria-label","aria-labelledby","aria-live","aria-owns","aria-relevant","aria-roledescription"],abstract:!0,name:"roletype"},{name:"row",nameFrom:["contents","author"],mustContain:["cell","columnheader","gridcell","rowheader"],supportedAttributes:["aria-colindex","aria-level","aria-rowindex","aria-selected","aria-setsize","aria-posinset"],superclasses:["group","widget"],scope:["grid","rowgroup","table","treegrid"]},{scope:["grid","table","treegrid"],superclasses:["structure"],name:"rowgroup",mustContain:["row"],nameFrom:["contents","author"]},{name:"rowheader",nameRequired:!0,nameFrom:["contents","author"],supportedAttributes:["aria-sort"],superclasses:["cell","gridcell","sectionhead"],scope:["row"]},{name:"scrollbar",nameRequired:!1,implicitValues:{"aria-valuemax":"100","aria-valuemin":"0","aria-orientation":"vertical"},nameFrom:["author"],requiredAttributes:["aria-controls","aria-orientation","aria-valuemax","aria-valuemin","aria-valuenow"],superclasses:["range"],childrenPresentational:!0},{superclasses:["landmark"],name:"search",nameFrom:["author"]},{superclasses:["textbox"],name:"searchbox",nameRequired:!0,nameFrom:["author"]},{supportedAttributes:["aria-expanded"],abstract:!0,name:"section",superclasses:["structure"]},{supportedAttributes:["aria-expanded"],abstract:!0,superclasses:["structure"],name:"sectionhead",nameFrom:["contents","author"]},{abstract:!0,superclasses:["composite","group"],name:"select",nameFrom:["author"]},{supportedAttributes:["aria-orientation","aria-valuemin","aria-valuemax","aria-valuenow","aria-valuetext"],superclasses:["structure"],name:"separator",nameFrom:["author"]},{name:"slider",nameRequired:!0,implicitValues:{"aria-valuemax":"100","aria-valuemin":"0","aria-orientation":"horizontal"},requiredAttributes:["aria-valuemax","aria-valuemin","aria-valuenow"],nameFrom:["author"],supportedAttributes:["aria-orientation"],superclasses:["input","range"],childrenPresentational:!0},{name:"spinbutton",nameRequired:!0,implicitValues:{"aria-valuenow":"0"},requiredAttributes:["aria-valuemax","aria-valuemin","aria-valuenow"],nameFrom:["author"],supportedAttributes:["aria-required","aria-readonly"],superclasses:["composite","input","range"]},{implicitValues:{"aria-atomic":"true","aria-live":"polite"},superclasses:["section"],name:"status",nameFrom:["author"]},{abstract:!0,name:"structure",superclasses:["roletype"]},{name:"switch",nameRequired:!0,implicitValues:{"aria-checked":"false"},nameFrom:["contents","author"],requiredAttributes:["aria-checked"],superclasses:["checkbox"],childrenPresentational:!0},{name:"tab",implicitValues:{"aria-selected":"false"},nameFrom:["contents","author"],supportedAttributes:["aria-selected"],superclasses:["sectionhead","widget"],childrenPresentational:!0,scope:["tablist"]},{name:"table",nameRequired:!0,nameFrom:["author"],mustContain:["row"],supportedAttributes:["aria-colcount","aria-rowcount"],superclasses:["section"]},{name:"tablist",implicitValues:{"aria-orientation":"horizontal"},nameFrom:["author"],mustContain:["tab"],supportedAttributes:["aria-level","aria-multiselectable","aria-orientation"],superclasses:["composite"]},{superclasses:["section"],name:"tabpanel",nameRequired:!0,nameFrom:["author"]},{superclasses:["section"],name:"term",nameFrom:["author"]},{supportedAttributes:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-placeholder","aria-readonly","aria-required"],superclasses:["input"],name:"textbox",nameRequired:!0,nameFrom:["author"]},{superclasses:["status"],name:"timer",nameFrom:["author"]},{implicitValues:{"aria-orientation":"horizontal"},supportedAttributes:["aria-orientation"],superclasses:["group"],name:"toolbar",nameFrom:["author"]},{superclasses:["section"],name:"tooltip",nameRequired:!0,nameFrom:["contents","author"]},{name:"tree",nameRequired:!0,implicitValues:{"aria-orientation":"vertical"},nameFrom:["author"],mustContain:["group","treeitem"],supportedAttributes:["aria-multiselectable","aria-required"],superclasses:["select"]},{nameRequired:!0,superclasses:["grid","tree"],name:"treegrid",mustContain:["row"],nameFrom:["author"]},{scope:["group","tree"],superclasses:["listitem","option"],name:"treeitem",nameRequired:!0,nameFrom:["contents","author"]},{abstract:!0,name:"widget",superclasses:["roletype"]},{supportedAttributes:["aria-expanded","aria-modal"],abstract:!0,superclasses:["roletype"],name:"window",nameFrom:["author"]}],metadata:{namespaceURI:"http://www.w3.org/1999/xhtml",attrsNullNamespace:!0,namespace:"HTML",export:"CORE_EXPORT",namespacePrefix:"xhtml"}};let O;class T{constructor(e){this._attributes=new Map,this._roleNames=[],e&&this._initialize(e)}_initialize(e){const t=e.attributes,a=["true","false"];for(const e of t)"boolean"===e.type&&(e.enum=a),this._attributes.set(e.name,new q(e));this._roleNames=e.roles.map((e=>e.name))}valuesForProperty(e){const t=this._attributes.get(e);return t?t.getEnum():"role"===e?this._roleNames:[]}}function D(){return O||(O=new T(V||null)),O}class q{constructor(e){this._enum=[],e.enum&&(this._enum=e.enum)}getEnum(){return this._enum}}var B=Object.freeze({__proto__:null,AttributeConfig:undefined,RoleConfig:undefined,Config:undefined,ARIAMetadata:T,ariaMetadata:D,Attribute:q});class X extends N{constructor(){super(ls`ARIA Attributes`),this._noPropertiesInfo=this.createInfo(ls`No ARIA attributes`),this._treeOutline=this.createTreeOutline()}setNode(e){if(super.setNode(e),this._treeOutline.removeChildren(),!e)return;const t=e.domModel().target(),a=e.attributes();for(let e=0;e<a.length;++e){const s=a[e];this._isARIAAttribute(s)&&this._treeOutline.appendChild(new W(this,s,t))}const s=0!==this._treeOutline.rootElement().childCount();this._noPropertiesInfo.classList.toggle("hidden",s),this._treeOutline.element.classList.toggle("hidden",!s)}_isARIAAttribute(e){return H.has(e.name)}}class W extends o.TreeElement{constructor(e,t,a){super(""),this._parentPane=e,this._attribute=t,this.selectable=!1}static createARIAValueElement(e){const t=document.createElement("span");return t.classList.add("monospace"),t.setTextContentTruncatedIfNeeded(e||""),t}onattach(){this._populateListItem(),this.listItemElement.addEventListener("click",this._mouseClick.bind(this))}_populateListItem(){this.listItemElement.removeChildren(),this.appendNameElement(this._attribute.name),this.listItemElement.createChild("span","separator").textContent=": ",this.appendAttributeValueElement(this._attribute.value)}appendNameElement(e){this._nameElement=document.createElement("span"),this._nameElement.textContent=e,this._nameElement.classList.add("ax-name"),this._nameElement.classList.add("monospace"),this.listItemElement.appendChild(this._nameElement)}appendAttributeValueElement(e){this._valueElement=W.createARIAValueElement(e),this.listItemElement.appendChild(this._valueElement)}_mouseClick(e){e.target!==this.listItemElement&&(e.consume(!0),this._startEditing())}_startEditing(){const e=this._valueElement;if(!e||d.isBeingEdited(e))return;const t=e.textContent||"";const a=this._nameElement.textContent||"";this._prompt=new z(D().valuesForProperty(a),this),this._prompt.setAutocompletionTimeout(0);this._prompt.attachAndStartEditing(e,function(e,t){const a=t.target.textContent||"";this._editingCommitted(a,e)}.bind(this,t)).addEventListener("keydown",this._editingValueKeyDown.bind(this,t),!1);const s=e.getComponentSelection();s&&s.selectAllChildren(e)}_removePrompt(){this._prompt&&(this._prompt.detach(),delete this._prompt)}_editingCommitted(e,t){if(this._removePrompt(),e!==t){this._parentPane.node().setAttributeValue(this._attribute.name,e)}}_editingCancelled(){this._removePrompt(),this._populateListItem()}_editingValueKeyDown(e,t){if(!t.handled){if(isEnterKey(t)){const a=t.target;return this._editingCommitted(a.textContent||"",e),void t.consume()}return isEscKey(t)?(this._editingCancelled(),void t.consume()):void 0}}}class z extends c.TextPrompt{constructor(e,t){super(),this.initialize(this._buildPropertyCompletions.bind(this)),this._ariaCompletions=e,this._treeElement=t}async _buildPropertyCompletions(e,t,a){return(t=t.toLowerCase())||a||!e?this._ariaCompletions.filter((e=>e.startsWith(t))).map((e=>({text:e,title:void 0,subtitle:void 0,iconType:void 0,priority:void 0,isSecondary:void 0,subtitleRenderer:void 0,selectionRange:void 0,hideGhostText:void 0,iconElement:void 0}))):[]}}const H=new Set(["role","aria-activedescendant","aria-atomic","aria-autocomplete","aria-brailleroledescription","aria-busy","aria-checked","aria-colcount","aria-colindex","aria-colindextext","aria-colspan","aria-controls","aria-current","aria-describedby","aria-details","aria-disabled","aria-dropeffect","aria-errormessage","aria-expanded","aria-flowto","aria-grabbed","aria-haspopup","aria-hidden","aria-invalid","aria-keyshortcuts","aria-label","aria-labelledby","aria-level","aria-live","aria-modal","aria-multiline","aria-multiselectable","aria-orientation","aria-owns","aria-placeholder","aria-posinset","aria-pressed","aria-readonly","aria-relevant","aria-required","aria-roledescription","aria-rowcount","aria-rowindex","aria-rowindextext","aria-rowspan","aria-selected","aria-setsize","aria-sort","aria-valuemax","aria-valuemin","aria-valuenow","aria-valuetext"]);var j=Object.freeze({__proto__:null,ARIAAttributesPane:X,ARIAAttributesTreeElement:W,ARIAAttributePrompt:z});class K extends N{constructor(e){super(ls`Accessibility Tree`),this.element.classList.add("ax-subpane"),u.markAsTree(this.element),this.element.tabIndex=-1,this._axSidebarView=e,this._preselectedBreadcrumb=null,this._inspectedNodeBreadcrumb=null,this._collapsingBreadcrumbId=-1,this._hoveredBreadcrumb=null,this._rootElement=this.element.createChild("div","ax-breadcrumbs"),this._rootElement.addEventListener("keydown",this._onKeyDown.bind(this),!0),this._rootElement.addEventListener("mousemove",this._onMouseMove.bind(this),!1),this._rootElement.addEventListener("mouseleave",this._onMouseLeave.bind(this),!1),this._rootElement.addEventListener("click",this._onClick.bind(this),!1),this._rootElement.addEventListener("contextmenu",this._contextMenuEventFired.bind(this),!1),this._rootElement.addEventListener("focusout",this._onFocusOut.bind(this),!1),this.registerRequiredCSS("accessibility/axBreadcrumbs.css",{enableLegacyPatching:!1})}focus(){this._inspectedNodeBreadcrumb?this._inspectedNodeBreadcrumb.nodeElement().focus():this.element.focus()}setAXNode(e){const t=this.element.hasFocus();if(super.setAXNode(e),this._rootElement.removeChildren(),!e)return;const a=[];let s=e;for(;s;)a.push(s),s=s.parentNode();a.reverse();let i=0,r=null,n=null;for(s of a)r=new G(s,i,s===e),n?n.appendChild(r):this._rootElement.appendChild(r.element()),n=r,i++;function o(e,t,a){const s=new G(t,a,!1);e.appendChild(s);for(const e of t.children())o(s,e,a+1)}if(this._inspectedNodeBreadcrumb=r,this._inspectedNodeBreadcrumb&&this._inspectedNodeBreadcrumb.setPreselected(!0,t),this._setPreselectedBreadcrumb(this._inspectedNodeBreadcrumb),this._inspectedNodeBreadcrumb)for(const t of e.children())o(this._inspectedNodeBreadcrumb,t,i),t.backendDOMNodeId()===this._collapsingBreadcrumbId&&this._setPreselectedBreadcrumb(this._inspectedNodeBreadcrumb.lastChild());this._collapsingBreadcrumbId=-1}willHide(){this._setPreselectedBreadcrumb(null)}_onKeyDown(e){const t=this._preselectedBreadcrumb;if(!t)return;const a=e;if(!a.composedPath().some((e=>e===t.element())))return;if(a.shiftKey||a.metaKey||a.ctrlKey)return;let s=!1;"ArrowUp"!==a.key||a.altKey?"ArrowDown"!==a.key||a.altKey?"ArrowLeft"!==a.key||a.altKey?(isEnterKey(a)||"ArrowRight"===a.key&&!a.altKey&&t.axNode().hasOnlyUnloadedChildren())&&(s=this._inspectDOMNode(t.axNode())):t.hasExpandedChildren()?this._collapseBreadcrumb(t):s=this._preselectParent():s=this._preselectNext():s=this._preselectPrevious(),s&&a.consume(!0)}_preselectPrevious(){if(!this._preselectedBreadcrumb)return!1;const e=this._preselectedBreadcrumb.previousBreadcrumb();return!!e&&(this._setPreselectedBreadcrumb(e),!0)}_preselectNext(){if(!this._preselectedBreadcrumb)return!1;const e=this._preselectedBreadcrumb.nextBreadcrumb();return!!e&&(this._setPreselectedBreadcrumb(e),!0)}_preselectParent(){if(!this._preselectedBreadcrumb)return!1;const e=this._preselectedBreadcrumb.parentBreadcrumb();return!!e&&(this._setPreselectedBreadcrumb(e),!0)}_setPreselectedBreadcrumb(e){if(e===this._preselectedBreadcrumb)return;const t=this.element.hasFocus();this._preselectedBreadcrumb&&this._preselectedBreadcrumb.setPreselected(!1,t),this._preselectedBreadcrumb=e||this._inspectedNodeBreadcrumb,this._preselectedBreadcrumb&&this._preselectedBreadcrumb.setPreselected(!0,t),!e&&t&&i.OverlayModel.hideDOMNodeHighlight()}_collapseBreadcrumb(e){if(!e.parentBreadcrumb())return;const t=e.axNode().backendDOMNodeId();null!==t&&(this._collapsingBreadcrumbId=t);const a=e.parentBreadcrumb();a&&this._inspectDOMNode(a.axNode())}_onMouseLeave(e){this._setHoveredBreadcrumb(null)}_onMouseMove(e){const t=e.target;if(!t)return;const a=t.enclosingNodeOrSelfWithClass("ax-breadcrumb");if(!a)return void this._setHoveredBreadcrumb(null);const s=U.get(a);s&&s.isDOMNode()&&this._setHoveredBreadcrumb(s)}_onFocusOut(e){this._preselectedBreadcrumb&&e.target===this._preselectedBreadcrumb.nodeElement()&&this._setPreselectedBreadcrumb(null)}_onClick(e){const t=e.target;if(!t)return;const a=t.enclosingNodeOrSelfWithClass("ax-breadcrumb");if(!a)return void this._setHoveredBreadcrumb(null);const s=U.get(a);return s?s.inspected()?(this._collapseBreadcrumb(s),void s.nodeElement().focus()):void(s.isDOMNode()&&this._inspectDOMNode(s.axNode())):void 0}_setHoveredBreadcrumb(e){if(e===this._hoveredBreadcrumb)return;this._hoveredBreadcrumb&&this._hoveredBreadcrumb.setHovered(!1);const t=this.node();e?e.setHovered(!0):t&&t.id&&t.domModel().overlayModel().nodeHighlightRequested({nodeId:t.id}),this._hoveredBreadcrumb=e}_inspectDOMNode(e){if(!e.isDOMNode())return!1;const a=e.deferredDOMNode();return a&&a.resolve((e=>{this._axSidebarView.setNode(e,!0),t.reveal(e,!0)})),!0}_contextMenuEventFired(e){const t=e.target;if(!t)return;const a=t.enclosingNodeOrSelfWithClass("ax-breadcrumb");if(!a)return;const s=U.get(a);if(!s)return;const i=s.axNode();if(!i.isDOMNode()||!i.deferredDOMNode())return;const r=new m.ContextMenu(e);r.viewSection().appendItem(ls`Scroll into view`,(()=>{const e=i.deferredDOMNode();e&&e.resolvePromise().then((e=>{e&&e.scrollIntoView()}))}));const n=i.deferredDOMNode();n&&r.appendApplicableItems(n),r.show()}}const U=new WeakMap;class G{constructor(e,t,a){if(this._axNode=e,this._element=document.createElement("div"),this._element.classList.add("ax-breadcrumb"),U.set(this._element,this),this._nodeElement=document.createElement("div"),this._nodeElement.classList.add("ax-node"),u.markAsTreeitem(this._nodeElement),this._nodeElement.tabIndex=-1,this._element.appendChild(this._nodeElement),this._nodeWrapper=document.createElement("div"),this._nodeWrapper.classList.add("wrapper"),this._nodeElement.appendChild(this._nodeWrapper),this._selectionElement=document.createElement("div"),this._selectionElement.classList.add("selection"),this._selectionElement.classList.add("fill"),this._nodeElement.appendChild(this._selectionElement),this._childrenGroupElement=document.createElement("div"),this._childrenGroupElement.classList.add("children"),u.markAsGroup(this._childrenGroupElement),this._element.appendChild(this._childrenGroupElement),this._children=[],this._hovered=!1,this._preselected=!1,this._parent=null,this._inspected=a,this._nodeElement.classList.toggle("inspected",a),this._nodeElement.style.paddingLeft=16*t+4+"px",this._axNode.ignored())this._appendIgnoredNodeElement();else{this._appendRoleElement(this._axNode.role());const e=this._axNode.name();e&&e.value&&(this._nodeWrapper.createChild("span","separator").textContent=" ",this._appendNameElement(e.value))}this._axNode.hasOnlyUnloadedChildren()&&(this._nodeElement.classList.add("children-unloaded"),u.setExpanded(this._nodeElement,!1)),this._axNode.isDOMNode()||this._nodeElement.classList.add("no-dom-node")}element(){return this._element}nodeElement(){return this._nodeElement}appendChild(e){this._children.push(e),e.setParent(this),this._nodeElement.classList.add("parent"),u.setExpanded(this._nodeElement,!0),this._childrenGroupElement.appendChild(e.element())}hasExpandedChildren(){return this._children.length}setParent(e){this._parent=e}preselected(){return this._preselected}setPreselected(e,t){this._preselected!==e&&(this._preselected=e,this._nodeElement.classList.toggle("preselected",e),this._nodeElement.tabIndex=e?0:-1,this._preselected&&(t&&this._nodeElement.focus(),this._inspected?i.OverlayModel.hideDOMNodeHighlight():this._axNode.highlightDOMNode()))}setHovered(e){this._hovered!==e&&(this._hovered=e,this._nodeElement.classList.toggle("hovered",e),this._hovered&&(this._nodeElement.classList.toggle("hovered",!0),this._axNode.highlightDOMNode()))}axNode(){return this._axNode}inspected(){return this._inspected}isDOMNode(){return this._axNode.isDOMNode()}nextBreadcrumb(){if(this._children.length)return this._children[0];const e=this.element().nextSibling;return e&&U.get(e)||null}previousBreadcrumb(){const e=this.element().previousSibling;return e?U.get(e)||null:this._parent}parentBreadcrumb(){return this._parent}lastChild(){return this._children[this._children.length-1]}_appendNameElement(e){const t=document.createElement("span");t.textContent='"'+e+'"',t.classList.add("ax-readable-string"),this._nodeWrapper.appendChild(t)}_appendRoleElement(e){if(!e)return;const t=document.createElement("span");t.classList.add("monospace"),t.classList.add(J[e.type]),t.setTextContentTruncatedIfNeeded(e.value||""),this._nodeWrapper.appendChild(t)}_appendIgnoredNodeElement(){const e=document.createElement("span");e.classList.add("monospace"),e.textContent=ls`Ignored`,e.classList.add("ax-breadcrumbs-ignored-node"),this._nodeWrapper.appendChild(e)}}const J={internalRole:"ax-internal-role",role:"ax-role"};var Q=Object.freeze({__proto__:null,AXBreadcrumbsPane:K,AXBreadcrumb:G,RoleStyles:J});class Y extends N{constructor(){super(ls`Source Order Viewer`),this._noNodeInfo=this.createInfo(ls`No source order information available`),this._warning=this.createInfo(ls`There may be a delay in displaying source order for elements with many children`),this._warning.id="source-order-warning",this._checked=!1,this._checkboxLabel=d.CheckboxLabel.create(ls`Show source order`,!1),this._checkboxElement=this._checkboxLabel.checkboxElement,this._checkboxLabel.classList.add("source-order-checkbox"),this._checkboxElement.addEventListener("click",this._checkboxClicked.bind(this),!1),this.element.appendChild(this._checkboxLabel),this._node=null,this._overlayModel=null}async setNodeAsync(e){if(this._checkboxLabel.classList.contains("hidden")||(this._checked=this._checkboxElement.checked),this._checkboxElement.checked=!1,this._checkboxClicked(),super.setNode(e),!this._node)return void(this._overlayModel=null);let t=!1;const a=this._node.childNodeCount();if(a>0){this._node.children()||await this._node.getSubtree(1,!1);t=this._node.children().some((e=>e.nodeType()===Node.ELEMENT_NODE))}this._noNodeInfo.classList.toggle("hidden",t),this._warning.classList.toggle("hidden",a<300),this._checkboxLabel.classList.toggle("hidden",!t),t?(this._overlayModel=this._node.domModel().overlayModel(),this._checkboxElement.checked=this._checked,this._checkboxClicked()):this._overlayModel=null}_checkboxClicked(){this._node&&this._overlayModel&&(this._checkboxElement.checked?(f.actionTaken(g.Action.SourceOrderViewActivated),this._overlayModel.highlightSourceOrderInOverlay(this._node)):this._overlayModel.hideSourceOrderInOverlay())}}let Z;class $ extends h.ThrottledWidget{constructor(){super(),this._sourceOrderViewerExperimentEnabled=_.experiments.isEnabled("sourceOrderViewer"),this._node=null,this._axNode=null,this._skipNextPullNode=!1,this._sidebarPaneStack=p.ViewManager.instance().createStackLocation(),this._breadcrumbsSubPane=new K(this),this._sidebarPaneStack.showView(this._breadcrumbsSubPane),this._ariaSubPane=new X,this._sidebarPaneStack.showView(this._ariaSubPane),this._axNodeSubPane=new w,this._sidebarPaneStack.showView(this._axNodeSubPane),this._sourceOrderViewerExperimentEnabled&&(this._sourceOrderSubPane=new Y,this._sidebarPaneStack.showView(this._sourceOrderSubPane)),this._sidebarPaneStack.widget().show(this.element),b.Context.instance().addFlavorChangeListener(s.DOMNode,this._pullNode,this),this._pullNode()}static instance(){return Z||(Z=new $),Z}node(){return this._node}axNode(){return this._axNode}setNode(e,t){this._skipNextPullNode=!!t,this._node=e,this.update()}accessibilityNodeCallback(e){e&&(this._axNode=e,e.isDOMNode()?this._sidebarPaneStack.showView(this._ariaSubPane,this._axNodeSubPane):this._sidebarPaneStack.removeView(this._ariaSubPane),this._axNodeSubPane&&this._axNodeSubPane.setAXNode(e),this._breadcrumbsSubPane&&this._breadcrumbsSubPane.setAXNode(e))}async doUpdate(){const e=this.node();if(this._axNodeSubPane.setNode(e),this._ariaSubPane.setNode(e),this._breadcrumbsSubPane.setNode(e),this._sourceOrderViewerExperimentEnabled&&this._sourceOrderSubPane&&this._sourceOrderSubPane.setNodeAsync(e),!e)return;const t=e.domModel().target().model(a.AccessibilityModel);t&&(t.clear(),await t.requestPartialAXTree(e),this.accessibilityNodeCallback(t.axNodeForDOMNode(e)))}wasShown(){super.wasShown(),this.doUpdate(),r.TargetManager.instance().addModelListener(s.DOMModel,s.Events.AttrModified,this._onAttrChange,this),r.TargetManager.instance().addModelListener(s.DOMModel,s.Events.AttrRemoved,this._onAttrChange,this),r.TargetManager.instance().addModelListener(s.DOMModel,s.Events.CharacterDataModified,this._onNodeChange,this),r.TargetManager.instance().addModelListener(s.DOMModel,s.Events.ChildNodeCountUpdated,this._onNodeChange,this)}willHide(){r.TargetManager.instance().removeModelListener(s.DOMModel,s.Events.AttrModified,this._onAttrChange,this),r.TargetManager.instance().removeModelListener(s.DOMModel,s.Events.AttrRemoved,this._onAttrChange,this),r.TargetManager.instance().removeModelListener(s.DOMModel,s.Events.CharacterDataModified,this._onNodeChange,this),r.TargetManager.instance().removeModelListener(s.DOMModel,s.Events.ChildNodeCountUpdated,this._onNodeChange,this)}_pullNode(){this._skipNextPullNode?this._skipNextPullNode=!1:this.setNode(b.Context.instance().flavor(s.DOMNode))}_onAttrChange(e){if(!this.node())return;const t=e.data.node;this.node()===t&&this.update()}_onNodeChange(e){if(!this.node())return;const t=e.data;this.node()===t&&this.update()}}var ee=Object.freeze({__proto__:null,AccessibilitySidebarView:$});export{j as ARIAAttributesView,B as ARIAMetadata,Q as AXBreadcrumbsPane,S as AccessibilityNodeView,ee as AccessibilitySidebarView,E as AccessibilityStrings,A as AccessibilitySubPane};
